# Bidder

The `Bidder` entity represents an account participating in the [auction](https://docs.casper.network/concepts/glossary/A/#auction) to become a [Validator](https://docs.cspr.cloud/1.0.x/rest-api/validator) for the era after the next one. It has the same properties as the Validator entity, with the network share value being projected instead of actual.

The `Bidder` entity has the following properties:

| Property            | Type         | Description                                                                                                                                                                                                        |
| ------------------- | ------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `rank`              | `uint8`      | Projected validator rank based on total bid amount                                                                                                                                                                 |
| `era_id`            | `uint32`     | Auction era identifier                                                                                                                                                                                             |
| `public_key`        | `string(68)` | Bidder account public key represented as a hexadecimal string                                                                                                                                                      |
| `is_active`         | `bool`       | Describes whether the bidder is active or not                                                                                                                                                                      |
| `fee`               | `float32`    | Percentage of the rewards the bidder will retain for its services once becomes a validator                                                                                                                         |
| `delegators_number` | `uint64`     | Number of delegators staked to the bidder                                                                                                                                                                          |
| `self_stake`        | `uint64`     | Bidder self-stake calculated as a sum of the bidder stake and the stakes of the affiliated accounts provided via the [Casper Account Info Standard](https://github.com/make-software/casper-account-info-contract) |
| `delegators_stake`  | `uint64`     | Cumulative stake of all delegators                                                                                                                                                                                 |
| `total_stake`       | `uint64`     | Total bidder stake. The sum of the self-stake and the delegator stakes.                                                                                                                                            |
| `self_share`        | `float32`    | Percentage of the bidder's self-stake to its total stake                                                                                                                                                           |
| `network_share`     | `float32`    | Projected network stake share if the bidder becomes a validator                                                                                                                                                    |

**Example**

```json
{
  "delegators_number": 1200,
  "delegators_stake": 328805467747474750,
  "era_id": 12104,
  "fee": 3,
  "is_active": true,
  "network_share": "3.86",
  "public_key": "01c377281132044bd3278b039925eeb3efdb9d99dd5f46d9ec6a764add34581af7",
  "rank": 2,
  "self_share": "0.02",
  "self_stake": 78323555658770,
  "total_stake": 328883791303133500
}
```

## Optional properties

Depending on the endpoint some of the following optional properties may be included in the `Bidder` entity:

| Property              | Type                                                                                   | Description                                                                                                            |
| --------------------- | -------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------- |
| `account_info`        | [`AccountInfo`](https://docs.cspr.cloud/1.0.x/rest-api/account-info)                   | Bidder [account info](https://github.com/make-software/casper-account-info-contract)                                   |
| `average_performance` | [`ValidatorPerformance`](https://docs.cspr.cloud/1.0.x/rest-api/validator-performance) | Moving average of validator performance based on the received rewards over the past 360 eras (approximately one month) |

## Relations

| Entity                                                                                  | Mapping property | Description                                                                    |
| --------------------------------------------------------------------------------------- | ---------------- | ------------------------------------------------------------------------------ |
| [`Account`](https://docs.cspr.cloud/1.0.x/rest-api/account)                             | `public_key`     | Auction bids are made by accounts                                              |
| [`Validator performance`](https://docs.cspr.cloud/1.0.x/rest-api/validator-performance) | `public_key`     | Bidders that were validators in the past have associated validator performance |

## Endpoints

The `Bidder` entity has the following endpoints:

* [Get bidder](https://docs.cspr.cloud/1.0.x/rest-api/bidder/get-bidder)
* [Get bidders](https://docs.cspr.cloud/1.0.x/rest-api/bidder/get-bidders)

## Relation endpoints

None


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/1.0.x/rest-api/bidder.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
